{- | HasGP Gaussian Process Library. This module contains the class definition 
     for log likelihoods.

     Copyright (C) 2011 Sean Holden. sbh11\@cl.cam.ac.uk.
-}
{- This file is part of HasGP.

   HasGP is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   HasGP is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HasGP.  If not, see <http://www.gnu.org/licenses/>.
-}
module HasGP.Likelihood.Basic 
   (
     LogLikelihood(..)
   ) where

import Numeric.LinearAlgebra

import HasGP.Types.MainTypes
import HasGP.Support.Functions

{- | The following allows arbitrary likelihoods with or without parameters 
     to be wrapped up with their derivatives (with respect to f) and passed 
     to a function.
-}
class LogLikelihood b where
    likelihood    :: b -> Double -> Double -> Double 
    dLikelihood   :: b -> Double -> Double -> Double
    ddLikelihood  :: b -> Double -> Double -> Double
    dddLikelihood :: b -> Double -> Double -> Double

