{- | MainTypes is a module in the HasGP Gaussian process library. It implements 
     basic types for the entire library. 

     Note: some more specific classes and types are defined elsewhere, 
     in particular in HasGP.Likelihood and HasGP.Covariance.

     Copyright (C) 2011 Sean Holden. sbh11\@cl.cam.ac.uk.
-}
{- This file is part of HasGP.

   HasGP is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   HasGP is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HasGP.  If not, see <http://www.gnu.org/licenses/>.
-}
module HasGP.Types.MainTypes where

import Numeric.LinearAlgebra

-- | These are defined to make functions more readable.
type DVector = Vector Double
type DMatrix = Matrix Double   

type Input = Vector Double
type Inputs = Matrix Double
type CovarianceMatrix = Matrix Double
type Targets = Vector Double
type Outputs = Vector Double

